unit Unit_pr;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

const
  WM_DLLUNLOAD = WM_USER+1;

type
  TDynNonmodal=procedure(AppHandle: THandle; NC: Pointer); stdcall;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure WMDLLUnload(var Message:TMessage);
    MESSAGE WM_DLLUNLOAD; {  }
   { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  FHLib: THandle;

procedure ReceiveCloseNotify; stdcall;
begin
 Application.ProcessMessages;
 PostMessage(Form1.Handle, WM_DLLUNLOAD, 0, 0);
end;

procedure TForm1.WMDLLUnload(var Message: TMessage);
begin
  Application.ProcessMessages;
  if FHLib <> 0 then FreeLibrary(FHLib);
  FHLib := 0;
  ShowMessage(' ');
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  DM: TDynNonmodal;
begin
  if FHLib = 0 then
    FHLib := LoadLibrary('FirstLib.dll');
  if FHLib > 0 then
    begin
      DM := GetProcAddress(FHLib, 'DynNonmodal');
      if Assigned(DM) then
        DM(Application.Handle, @ReceiveCloseNotify);
    end;
end;

end.
